\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\
\\ Beispieleingabe 1:
\\
\\ p=nextprime(2^50);
\\ N=p+2+random(floor(sqrt(p)));  (also N<>p+1)
\\ e=eCC(N,p);
\\
\\ Rckgabe ist ein Vektor e=[A,B] mit den
\\ Parametern einer elliptischen Kurve,
\\ die N Punkte ber F_p besitzt.
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\
\\ Beispieleingabe 2:
\\
\\ N=random(2^100);
\\ fN=factor(N);
\\ p=broeker(N,fN);
\\ e=eCC(N,p[1],p[2],p[3]);
\\
\\ Rckgabe ist ein Vektor e=[A,B] mit den
\\ Parametern einer elliptischen Kurve,
\\ die N Punkte ber F_p[1] besitzt.
\\ p[1] wir hierbei mit dem Verfahren von Brker
\\ und Stevenhagen gefunden.
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Konstruktion einer elliptischen Kurve E ber
\\               F_p mit N Punkten.
\\
\\ Eingabe:  p>3 prim, N im Hasse-Intervall,
\\           N != p+1.
\\ Optional: Diskriminante des ZK, Frobenius pi
\\ Rckgabe: Kurvenparameter A und B.
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

eCC(N,p,D=0,pi=0)=
{
     local(tmp, prec, cl_poly, j_inv, A, B, A2, B2, P, Q, om, einh, u, v, C);

	 default(realprecision,ceil(log(N)/log(10)));
     tmp = (p+1-N)^2-4*p;

	 \\ wenn die Diskriminante nicht bergeben wir, berechne sie
     if(!D,
         D=quaddisc(tmp);
         print("Diskriminante: ",D);
     );

	 \\ precision ermitteln
\\	 default(realprecision,10);
	 print1("Rechengenauigkeit ermitteln... ");
	 prec = ePrecision(D);
	 default(realprecision, prec);

	 \\ KLassenpolynom aufstellen
     print1("Klassenpolynom aufstellen");
     cl_poly = KlassenPoly(D);
\\	 print(cl_poly);

     \\ Nullstellen modulo p berechnen
     print("Nullstelle des Klassenpolynoms modulo p bestimmen...");
\\     print1("Nullstelle des Klassenpolynoms modulo ");print1(p);print(" bestimmen...");
\\     tmp = polrootsmod(cl_poly,p);

\\	 print(tmp);


	 \\ erste Nullstelle auswhlen
\\     j_inv = lift(tmp[1]);
     j_inv = BerlekampRabin(cl_poly,p);
\\	 print("Ausgewhlte Nullstelle: ",j_inv);


     if(j_inv%p && (j_inv-1728)%p,

     	  print("Parameter der Kurve und ihres Twists ermitteln...");

          \\ Parameter bestimmen
          tmp = 1728-j_inv;
\\          print(tmp);

          A=lift(Mod(3*j_inv,p)/tmp); B=lift(Mod(2*j_inv,p)/tmp);
\\          print("A: ",A," B: ",B);
\\          print("Kurve: y^2=x^3+",A,"x+",B);

		  \\ und die des Twists
          tmp=eTwist(A,B,p);
          A2=tmp[1];B2=tmp[2];
\\          print("Twist: y^2=x^3+",A2,"x+",B2);

          \\ richtige Kurve auswhlen
     	  print("Richtige Kurve auswhlen...");
          while(1,

                \\ Punkte auf den Kurven bestimmen
				P = eRandomPoint(A,B,p);
				Q = eRandomPoint(A2,B2,p);
\\				print("P: ",P," Q: ",Q);

                \\ Berechne Vielfaches der Punkte
                P=eMult(A,p,P,N); Q=eMult(A2,p,Q,N);
\\				print("N*P: ",P," N*Q: ",Q);

                if(P==[0] && Q!=[0], return([A,B]));

                if(P!=[0] && Q==[0], return([A2,B2]));

                if(P!=[0] && Q!=[0], print("Fehler: p ist nicht prim!");break(););
          );
     ,
     	  if((j_inv-1728)%p,

		  \\ Fall j_inv = 0 mod p            => Z[\rho]
				print("Es ist j==0 mod p: Suche Kurvengleichung ...");

     	  		\\ Bestimmung einer Lsg "pi" von N(pi)=p (Z[\rho] ist HI-Ring)
     	  		\\ falls der Frobenius nicht bergeben wird
     	  		if(pi==0,
                    tmp=lift(polrootsmod(keinname^2-keinname+1,p)[1]);
                    tmp = LLL([p,0],[-tmp,1],D);

                    \\ finden des Frobenius "pi" der Kurve (misbrauche A,B)
                    for(A=-1,1,
                        for(B=-1,1,
                            einh=[A,B];
                            pi=FieldMult(einh,tmp,D);
                            if(FieldTrace(pi,D) == p+1-N,
                                break(2)
                            )
                        )
                    )
                );
\\				print("Frobenius: ",pi);

				\\ Herleitung von "om" in Z[\rho] mit N(om)=p und om==2 mod 3
				\\ und von "einh" mit om=einh*pi
				einh=vector(2);
				einh[1]=(-pi[1])%3;  if(einh[1]>1,einh[1]-=3);
				einh[2]=pi[2]%3;     if(einh[2]>1,einh[2]-=3);
				einh[1]-=einh[2];
				om=FieldMult(einh,pi,D);
\\				print("Einheit: ",einh);

                \\ finde C
				tmp=bezout(pi[1],pi[2]);
\\				print("Bezout: ",tmp);

				v=tmp[1]*(einh[2]/tmp[3]);
				u=tmp[2]*(einh[2]/tmp[3]);
				C=((pi[1]+pi[2])*u-einh[1]-einh[2]-pi[2]*v)%p;
\\				print("u: ",u," v: ",v, " C: ", C);

				tmp=random(p);
				while( (lift(Mod(tmp,p)^((p-1)/6))-C)%p,
					tmp=random(p);
				);

				B=lift(Mod(tmp,p)/4);
				return([0,B])
     	  ,
     	  \\ Fall j_inv = 1728 mod p         => Z[i]
				print("Es ist j==1728 mod p: Suche Kurvengleichung ...");

     	  		\\ Bestimmung einer Lsg "pi" von N(pi)=p (Z[i] ist HI-Ring)
     	  		\\ falls der Frobenius nicht bergeben wird
     	  		if(pi==0,
                    tmp=lift(polrootsmod(keinname^2+1,p)[1]);
                    pi = LLL([p,0],[-tmp,1],D);

                    \\ finden des Frobenius "pi" der Kurve
                    while(FieldTrace(pi,D)!=p+1-N, pi=FieldMult([0,1],pi,D) )
                );
\\				print("Frobenius: ",pi);

				\\ Finde "einh" mit om=einh*pi
				einh=vector(2);
				if(pi[1]%2,
					einh[2]=0;
					einh[1]=(pi[1]-pi[2])%4; if(einh[1]==3,einh[1]=-1)
				,
					einh[1]=0;
					einh[2]=(pi[1]-pi[2])%4; if(einh[2]==3,einh[2]=-1)
				);
\\				print("Einheit: ",einh);

				\\ Finde A
				tmp=bezout(pi[1],pi[2]);
\\				print("Bezout: ",tmp);

				if(einh[2]%tmp[3],
					print("FEHLER!!!!");
					return();
				);

				v=tmp[1]*(-einh[2]/tmp[3]);
				u=tmp[2]*(-einh[2]/tmp[3]);
				C=(einh[1]+pi[1]*u-pi[2]*v)%p;
\\				print("u: ",u," v: ",v, " C: ",C);
				A=random(p);
				while( (lift(Mod(-A,p)^((p-1)/4)) -C)%p,
					A=random(p)
				);
				return([A,0])

     	  )
     )
}



\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Berechnet das Klassenpolynom
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
KlassenPoly(D)=
{
     local(a,b,c, sqrtD, tmp, t_POLY g);

     g = 1; sqrtD=sqrt(D);

     tmp = nextideal(-1,0,D);
     while(tmp[1]>0,

          a=tmp[1];b=tmp[2];c=tmp[3];

          if(b==a || c==a,

               g *= (X- ellj( (b+sqrtD)/(2*a) ));
               print1(".");
          ,

               if(b!=0,
					\\ die j-Invariante des Konjugierten ist die konjugierte j-Invariante
               		tmp = ellj( (b+sqrtD)/(2*a) );
               		g *= (X - tmp); g *= (X - conj(tmp));
	                print1("..");
               ,
                    g *= (X - ellj( (b+sqrtD)/(2*a) ));
	                print1(".");
               );
          );

          tmp = nextideal(a,b,D);
     );
     print1("\n");
     return(round(g));
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Berechnet eine Nullstelle des Poly poly(X) mod p
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
BerlekampRabin(poly,p)=
{
	local(deg,tmp,g,f,ggT);

	deg=poldegree(poly);
	for(i=0,deg,f+=Mod(polcoeff(poly,i),p)*X^i);


	until(deg==1,

		tmp=Mod(random(p),p);
		if(subst(f,X,tmp)==0,return(lift(tmp)));

		g=Mod(1,p)*X+tmp;

		tmp=Mod(g,f)^((p-1)/2);


		ggT=gcd(lift(tmp)-1,f);


		if(poldegree(ggT)>0 && poldegree(ggT)<deg,
			f=ggT;
			deg=poldegree(f);
		);

	);


   	return((p-lift(polcoeff(f,0)/lift(polcoeff(f,1))))%p);

}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ gibt das nchste Ideal in der Klassengruppe
\\ mit Diskriminante D zurck
\\ (ist a_alt=-1, so wird das erste Ideal ermittelt)
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
nextideal(a_alt, b_alt, D)=
{
     local(a, b, c, bkong, temp);

     bkong=D%2;
     if(a_alt>=0,
          a = a_alt;
          b = b_alt + 2;
     ,
          a=floor(sqrt(-D/3));
          b=lift(Mod(D,2));
     );
     while(a>0,
          while(b<=a,
               temp = D-b^2;
               if(temp%a==0,
                    temp = temp/a;
                    if(temp%4==0,
                         c=-temp/4;
                         if(c>= a,
                              return([a,b,c]);
                         );
                    );
               );
               b+=2;
          );
          b=bkong;
          a--;
     );
     return([-1,0,0]);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Addition auf ell. Kurven
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
eAdd(A, p, P, Q)=
{
     local(tmp,m,x,y);

     if(P==[0],if(Q==[0],return([0]),return(Q)));
     if(Q==[0],return(P));

     if(P[1]!=Q[1],
          m = Mod(Q[2]-P[2],p);
          m /= (Q[1]-P[1]);    m=lift(m);
          x = m^2-P[1]-Q[1];   x=lift(Mod(x,p));
          y = m*(P[1]-x)-P[2]; y=lift(Mod(y,p));
          return([x,y]);
     );

     \\ es ist ab hier P[1]==Q[1]

     if(P[2]!=Q[2], return([0]));

     \\ es ist ab hier P==Q

     if(P[2]==0, return([0]));

     \\ es ist ab hier P==Q und P[2]!=0

     m = Mod(3*P[1]^2+A,p);
     m /= 2*P[2];         m=lift(m);
     x = m^2-2*P[1];      x=lift(Mod(x,p));
     y = m*(P[1]-x)-P[2]; y=lift(Mod(y,p));
     return([x,y]);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Multiplikation auf ell. Kurven
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
eMult(A,p,P,n)=
{
     local(Q);

     Q=[0];
     while(n!=0,
          if(n%2==0,
               \\ n ist gerade
               n /=2;
               P = eAdd(A,p,P,P);
          ,
               \\ n ist ungerade
               n--;
               Q = eAdd(A,p,P,Q);
          );
     );
     return(Q);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ zuflliger Punkt auf E
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
eRandomPoint(A,B,p)=
{
	local(x);

    x=random(p);
    while(kronecker(x^3+A*x+B,p)==-1,x=random(p));
    return([x,sqrtmod(x^3+A*x+B,p)]);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Twist von E (im Fall D<-4)
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
eTwist(A,B,p)=
{
	local(ns);

    \\ twisted Parameter bestimmen
    ns=2;while(kronecker(ns,p)!=-1,ns++);
\\    print("Nichtquadrat: ",ns);
    A=lift(Mod(A*ns^2,p)); B=lift(Mod(B*ns^3,p));
	return([A,B]);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Berechnet Quadratwurzeln modulo p
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
sqrtmod(a,p)=
{
	if(kronecker(a,p)!=1,return(0));
	return(lift(polrootsmod(X^2-a,p)[1]));
}


\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Durchluft die Klassengruppe
\\ (wird von eCC nicht benutzt, kann aber zum
\\  Ermitteln der Klassenzahl verwendet werden.)
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Idealklasse(D,flag=0)=
{
        local(a,b,c, klassenzahl, tmp);

        klassenzahl = 0;

        tmp = nextideal(-1,0,D);
        while(tmp[1]>0,

        	a=tmp[1];b=tmp[2];c=tmp[3];

            if(b==a || c==a,

                if(flag==0,
                    print1(".")
                ,
                    print1("[");print1(a);print1(",");print1(b);print1(",");print1(c);print("]");
                );
                klassenzahl++;
            ,
                if(b!=0,
                    if(flag==0,
                        print1("..")
                    ,
                        print1("[");print1(a);print1(",");print1(b);print1(",");print1(c);print("]");
                        print1("[");print1(a);print1(",");print1(-b);print1(",");print1(c);print("]");
                    );
                    klassenzahl+=2;
                ,
                    if(flag==0,
                        print1(".")
                    ,
                        print1("[");print1(a);print1(",");print1(b);print1(",");print1(c);print("]");
                    );
                    klassenzahl++;
                );
            );
            tmp = nextideal(a,b,D);

        );
        print1("Klassenzahl: ");print(klassenzahl);
        return(klassenzahl)
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Berechnet die bentigte precision
\\ (nach dem Vorschlag von Lay/Zimer)
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
ePrecision(D)=
{
    local(a, b, c, prec, klassenzahl, tmp);

    klassenzahl = 0;
    prec = 0;

    tmp = nextideal(-1,0,D);
    while(tmp[1]>0,

        a=tmp[1];b=tmp[2];c=tmp[3];

        if(b==a || c==a,
            prec += (1/a);
            klassenzahl++;
        ,
            if(b!=0,
                prec += (2/a);
                klassenzahl+=2;
            ,
                prec += (1/a);
                klassenzahl++;
            );
        );
        tmp = nextideal(a,b,D);
    );

	prec *=(Pi*sqrt(-D));
	prec /= log(10);
	prec += (5 + (klassenzahl/3));
	prec = ceil(prec);

    print1("prec=");print1(prec);print1(" (Klassenzahl: ");print1(klassenzahl);print1(")\n");
	return(prec);
}








\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\      Verfahren von Broeker / Stevenhagen
\\ Eingabe: Zahl N, fN=factor(N)
\\ Optional: "Start-Diskriminante"
\\ Ausgabe: Primzahl p, Diskriminante D,
\\          Frobenius pi
\\ so dass eine ell. Kurve ber F_p mit Gruppen-
\\ ordnung N existiert.
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
broeker(N,fN,D=-1)=
{
	local(roots, r, k, k1, k2, N1,fN1, N0, n, fDiv, pi, p, i, tmp, info);


	D=NextDiscriminant(D);
	info=1;
	print1("Primzahl finden ");
	while(1,


		tmp = brFindK1(D,N,fN);
		k1=tmp[1]; fN1=tmp[2];

		if(k1,

			N1 = N/(k1^2);
\\			print("k1= ",k1, " N1= ",N1," fN1= ",fN1);

			\\ Nullstellen modulo N1 bestimmen
	        if(D%4==1,
	        	roots=polrootsmodN(keinname^2-keinname+(1-D)/4,N1,fN1),
		        roots=polrootsmodN(keinname^2-D,N1,fN1)
		    );
\\			print("NS modulo N1: ",roots);

            \\ Berechne alle quadratischen Teiler k2^2 von N1
            n=matsize(fN1)[1];
            fDiv=fN1;
            for(i=1,n, fDiv[i,2]=0);

            until(fDiv==[0],

                k2=1;for(i=1,n,k2*=(fDiv[i,1]^fDiv[i,2]));
                k=k1*k2; N0=N1/(k2^2);
\\				print("k= ",k, " N0= ",N0);

                \\ durchlaufe alle NS modulo N1
                for(i=1, matsize(roots)[1],

                    r=lift(roots[i]);
\\					print("NS: ",r);

                    \\ Suche Element minimaler Norm
                    tmp = LLL([N0,0],[-r,1],D);

                    \\ ist dies ein Erzeuger?
                    if(FieldNorm(tmp,D)==N0,

\\						print("Kandidat pi: ",pi);

						if((D+3) && (D+4),

							\\ Fall D!= -3,-4  => quadratische Twiste beachten

                            \\ ist die Norm p eines Frob. prim?
                            pi=k*tmp;
                            p=N+1-FieldTrace(pi,D);      \\ fr pi
							if(ispseudoprime(p),
                                if(isprime(p),
                                    print1("   ",info,". Versuch erfolgreich!\n");
                                    return([p,D,pi])
                                )
                            );
                            pi=-k*tmp;
                            p=N+1-FieldTrace(pi,D);      \\ fr -pi
							if(ispseudoprime(p),
                                if(isprime(p),
                                    print1("   ",info,". Versuch erfolgreich!\n");
                                    return([p,D,pi])
                                )
							)
						,
							if(D+3,
								\\ Fall D=-4 => quartische Twiste beachten

								pi=k*tmp;
                                p=N+1-FieldTrace(pi,D);     \\ fr pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=-k*tmp;
                                p=N+1-FieldTrace(pi,D);     \\ fr -pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
								);
                                pi=k*FieldMult(tmp,[0,1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr i*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
								);
                                pi=k*FieldMult(tmp,[0,-1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr -i*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                )
							,
								\\ Fall D=-3 => sextische Twiste beachten

								pi=k*tmp;
                                p=N+1-FieldTrace(pi,D);     \\ fr pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=-k*tmp;
                                p=N+1-FieldTrace(k*pi,D);     \\ fr -pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=k*FieldMult(tmp,[-1,1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr rho*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=k*FieldMult(tmp,[1,-1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr -rho*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=k*FieldMult(tmp,[0,-1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr rho^2*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                );
                                pi=k*FieldMult(tmp,[0,1],D);
                                p=N+1-FieldTrace(pi,D);      \\ fr -rho^2*pi
								if(ispseudoprime(p),
                                    if(isprime(p),
                                        print1("   ",info,". Versuch erfolgreich!\n");
                                        return([p,D,pi])
                                    )
                                )
							)
						)
                    )
                );
                fDiv=brNextSquareDiv(fDiv,fN1,n)
            )
		);
		D=NextDiscriminant(D);
		if(!(info%1000),print1("."));
		info++
	)
}




\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Eine Spezialisierung des LLL-Algorithmus zur
\\            Gitterbasisreduktion
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
LLL(v1,v2,disc)=
{
	local(x,y,l,tmp);

	x=Field2Basis(v1,disc);
	y=Field2Basis(v2,disc);
\\	print("x=",x," y=",y);

	while(1,

		l=BasisSkalar(x,y,disc);
		l/=BasisNorm(y,disc);
\\		print1("lambda=",l);
		l=floor(l+0.5);
\\		print("~",l);

		x -= (l*y);

		if(BasisNorm(x,disc)<BasisNorm(y,disc),
			tmp=x;x=y;y=tmp;
		,
\\			print("  x=",x," y=",y);
			return(Basis2Field(y,disc))
		);
\\		print("  x=",x," y=",y);
	)
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Formatkonvertierung
\\
\\ Krperdarstellung mit Basis: 1, sqrt(N) bzw.
\\     1, (1+sqrt(N))/2 in Abh. von N mod 4
\\ "Basis"-Darstellung mit Basis: 1/2, sqrt(D)/2
\\     UNABHNGIG von D=quaddisc(N)!!!!
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
Field2Basis(elem,disc)=
{
	if(disc%4==1,
		return( [2*elem[1]+elem[2], elem[2]] )
	,
		return([2*elem[1],elem[2]])
	)
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Formatkonvertierung
Basis2Field(elem,disc)=
{
	if(disc%4==1,
		return( [(elem[1]-elem[2])/2, elem[2]] )
	,
		return( [elem[1]/2, elem[2]] )
	)
}
BasisSkalar(v1,v2,disc)=
{
	return( (v1[1]*v2[1]-disc*v1[2]*v2[2])/4 )
}
BasisNorm(v,disc)=
{
	return(BasisSkalar(v,v,disc))
}
FieldNorm(v,disc)=
{
	if(disc%4==1,
		return(v[1]^2+v[1]*v[2]+((1-disc)/4)*v[2]^2)
	,
		return(v[1]^2-(disc/4)*v[2]^2)
	)
}
FieldTrace(v,disc)=
{
	if(disc%4==1,
		return(2*v[1]+v[2])
	,
		return(2*v[1])
	)
}
\\ Multiplikation zweier Krperelemente
FieldMult(v,w,disc)=
{
	if(disc%4==1,
		return([v[1]*w[1]+((disc-1)/4)*v[2]*w[2],v[2]*w[1]+v[1]*w[2]+v[2]*w[2]])
	,
		return([v[1]*w[1]+(disc/4)*v[2]*w[2],v[1]*w[2]+v[2]*w[1]])
	)
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Unterfunktion berechnet nchsten quadr. Teiler
brNextSquareDiv(f,fMax,n)=
{
	local(i);

	i=1;
	while(f[i,2]>=floor(fMax[i,2]/2),
		f[i,2]=0;
		i++;
		if(i>n, break)
	);
	if(i<=n,
		f[i,2]++;
		return(f)
	,
		return([0])
	)
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Unterfunktion
brFindK1(D,N,faktoren)=
{
	local(i,K1,lgdr,fN1);
	K1=1;
	fN1=faktoren;

\\	print("\nTeste Verzweigungsverhalten: (D=",D,")");
	for(i=1, matsize(faktoren)[1],


		lgdr=kronecker(D,faktoren[i,1]);
\\		print(faktoren[i,1]," mit lgdr: ",lgdr);

		\\ p_i bleibt prim
		if(lgdr == -1,
			if(faktoren[i,2]%2==0,

				fN1[i,2]=0;
				K1*=faktoren[i,1]^(floor(faktoren[i,2]/2))
			,
				\\ Abbruch
				return([0,0])
			)
		);

		\\ p_i ist verzweigt
		if(lgdr==0,
			if(faktoren[i,2]%2==1,
				fN1[i,2]=1
			);
			K1*=faktoren[i,1]^(floor(faktoren[i,2]/2))
		)

		\\ p_i ist vollst. zerlegt -> tue nichts

	);
	return([K1,fN1])
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\   gibt die nchste Fundamentaldiskriminante
\\                < D zurck
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
NextDiscriminant(D)=
{
	while(1,
		D-=1;
		if(isfundamental(D), return(D))
	)
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\   Berechnet die Lsungen von f(x)=0 mod N
\\
\\ EINGABE: Poly f in der Variabeln "keinname",
\\ N natrliche Zahl, fN Faktorisierung von N
\\ AUSGABE: Liste der Nullstellen
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
polrootsmodN(f,N,fN)=
{
	local(list, roots, i, j, anzf, tmp, deg, flag, x, m);

	anzf=matsize(fN)[1];
	deg =poldegree(f);
	roots=matrix(anzf,deg+2);


	\\ Fr jeden Primfaktor p von N
	for(i=1,anzf,

		\\ Berechne Nullstellen mod p
		tmp=polrootsmod(f,fN[i,1]);

		\\ Hebe jede Nullstelle zu NS mod p^e
		for(j=1,matsize(tmp)[1],
			roots[i,j]=hensel(lift(tmp[j]),f,fN[i,1],fN[i,2]);
		);
		roots[i,deg+1]=matsize(tmp)[1];
	);

	list=vector(anzf*deg);j=1;

	\\ Setze mit chin. Restesatz zu Nullstellen modulo N zusammen
	for(i=1,anzf,roots[i,deg+2]=1);
	flag=1;
	while(flag,

		x=roots[1,roots[1,deg+2]];m=fN[1,1]^fN[1,2];
		for(i=2,anzf,
			x =  chinRest(x,m,roots[i,roots[i,deg+2]],fN[i,1]^fN[i,2]);
			m *= (fN[i,1]^fN[i,2]);
		);
		if(!setsearch(Set(list),x),list[j]=x;j++);


		\\ nchste Permutation bestimmen
		i=1;
		while(roots[i,deg+2]>=roots[i,deg+1],
            roots[1,deg+2]=1;
            i++;
            if(i>anzf,break)
		);
		if(i<=anzf, roots[i,deg+2]++, flag=0)
	);

	return(list);
}

\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\      Liftet die Lsung f(w)= 0 mod p
\\     zu einer Lsung von f(x)=0 mod p^k
\\
\\ EINGABE: f Polynom in Variablen "keinname",
\\ p prim, k>0, w Lsg von f(x)=0 mod p
\\ AUSGABE: Nullstelle von f mod p^k, sonst 0
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
hensel(w,f,p,k)=
{
	local(i, inv, t, fab);


	fab=f';		\\ Ableitung von f

	if(subst(fab,keinname,w)%p,

		inv=lift(Mod(subst(fab,keinname,w),p)^(-1));

		\\ Fall: f'(w)<>0 mod p
		i=1;
		while(i<=k,
			t=-subst(f,keinname,w); t/=p^(i-1);
			t*=inv; t=t%p;

			w=w+t*p^(i-1);
			i++;
		);
		return(w)

	,
		\\ Fall: f'(w)==0 mod p
		if(subst(f,keinname,w)%p^k,
			print("Es existieren keine Lsungen!")
		,
			return(w)
		)
	)
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ Berechnet fr teilerfremde m1, m2 zu beliebi-
\\ gen x1, x2 eine gemeinsame Lsung x mit
\\ x=x1 mod m1, x=x2 mod m2
\\
\\ EINGABE: teilerfremde m1, m2, beliebige x1, x2
\\ AUSGABE: x wie oben
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
chinRest(x1, m1, x2, m2)=
{
	local(inv,s);

	inv=lift(Mod(m1,m2)^(-1));
	s= ((x2-x1)*inv)%m2;
	return(x1+s*m1);
}
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ (sehr langsamer) Algorithmus zur Bestimmung
\\              der Klassenzahl
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
ClassNumber(D)=
{
	local(h,r);

	if(D>=0,print("Diskriminante muss negativ sein!")
	,
		h=0;
		for(r=1,-D-1,
			h += kronecker(D,r)*r;
		);
		if(D==-3, h *= 3, if(D==-4, h *= 2));
		h /= D;
		return(h);
	);
}